Package com.sun.java.help.impl

# Class JHSecondaryViewer

java.lang.Object
java.awt.Component
java.awt.Container
javax.swing.JComponent
javax.swing.AbstractButton
javax.swing.JButton
com.sun.java.help.impl.JHSecondaryViewer

All Implemented Interfaces:
  `ViewAwareComponent`, `ActionListener`, `ImageObserver`, `ItemSelectable`, `MenuContainer`, `Serializable`, `EventListener`, `Accessible`, `SwingConstants`

public class JHSecondaryViewer extends JButton implements ActionListener, ViewAwareComponent
This class is a secondary viewer to be included in HTML content within JHContentViewer. The ViewerType can either be a SecondaryWindow or a Popup. Activation is done be either a Button or a mouse enabled Label. Both Button and Label support Text, Icon, or Text and Icon.

To use this class within HTML content use the invalid input: '&ltobject'invalid input: '&gt' tag. Below is an example usage:

     invalid input: '&ltobject' CLASSID="java:com.sun.java.help.impl.JHSecondaryViewer"invalid input: '&gt'
     invalid input: '&ltparam' name="content" value="secondary_contents.html"invalid input: '&gt'
     invalid input: '&ltparam' name="viewerActivator" value="javax.help.LinkLabel"invalid input: '&gt'
     invalid input: '&ltparam' name="viewerStyle" value="javax.help.Popup"invalid input: '&gt'
     invalid input: '&ltparam' name="viewerSize" value="300,400"invalid input: '&gt'
     invalid input: '&ltparam' name="text" value="Click here"invalid input: '&gt'
     invalid input: '&ltparam' name="textFontFamily" value="SansSerif"invalid input: '&gt'
     invalid input: '&ltparam' name="textFontSize" value="x-large"invalid input: '&gt'
     invalid input: '&ltparam' name="textFontWeight" value="plain"invalid input: '&gt'
     invalid input: '&ltparam' name="textFontStyle" value="italic"invalid input: '&gt'
     invalid input: '&ltparam' name="textColor" value="red"invalid input: '&gt'
     invalid input: '&lt'/objectinvalid input: '&gt'

Valid parameters are:

- content - a valid url, can be relative to the current viewer

See Also:
  - ``
  - id - a valid id from the current HelpSet
  - ``
  - viewerName - the name of the SecondaryWindow to display the content in
  - ``
  - viewerActivator - the activator type for the viewer. Either "javax.help.LinkButton" or "javax.help.LinkLabel"
  - ``
  - viewerStyle - the style of the viewer. Either "SecondaryWindow" or "Popup"
  - ``
  - viewerLocation - the x,y coordinates applied to a secondary window.
  - ``
  - viewerSize - the width, height applied to a viewer.
  - ``
  - iconByName - the url or id of a icon to be displayed in the activator. The url is relative to the base address of the document
  - ``
  - text - the text of the activator
  - ``
  - textFontFamily - the font family of the activator text
  - ``
  - textFontSize - the size of the activator text font. Size is specified in a css termonolgy. See the setTextFontSize for acceptable syntax
  - ``
  - textFontWeight - the activator text font weight
  - ``
  - textFontStyle - the activator text font style
  - ``
  - textColor - the activator text color
  - `
    `
  - invalid reference

        JHSecondaryWindowBeanInfo

  - Serialized Form

## Nested Class Summary

## Nested classes/interfaces inherited from class javax.swing.JButton

`JButton.AccessibleJButton`

## Nested classes/interfaces inherited from class javax.swing.AbstractButton

`AbstractButton.AccessibleAbstractButton, AbstractButton.ButtonChangeListener`

## Nested classes/interfaces inherited from class javax.swing.JComponent

`JComponent.AccessibleJComponent`

## Nested classes/interfaces inherited from class java.awt.Container

`Container.AccessibleAWTContainer`

## Nested classes/interfaces inherited from class java.awt.Component

`Component.AccessibleAWTComponent, Component.BaselineResizeBehavior, Component.BltBufferStrategy, Component.FlipBufferStrategy`

## Field Summary

Fields
Modifier and Type
Field
Description
`static String`
`LINK_BUTTON`
`static String`
`LINK_LABEL`
`static String`
`POPUP`
`static String`
`SECONDARY_WINDOW`

### Fields inherited from class javax.swing.AbstractButton

`actionListener, BORDER_PAINTED_CHANGED_PROPERTY, changeEvent, changeListener, CONTENT_AREA_FILLED_CHANGED_PROPERTY, DISABLED_ICON_CHANGED_PROPERTY, DISABLED_SELECTED_ICON_CHANGED_PROPERTY, FOCUS_PAINTED_CHANGED_PROPERTY, HORIZONTAL_ALIGNMENT_CHANGED_PROPERTY, HORIZONTAL_TEXT_POSITION_CHANGED_PROPERTY, ICON_CHANGED_PROPERTY, itemListener, MARGIN_CHANGED_PROPERTY, MNEMONIC_CHANGED_PROPERTY, model, MODEL_CHANGED_PROPERTY, PRESSED_ICON_CHANGED_PROPERTY, ROLLOVER_ENABLED_CHANGED_PROPERTY, ROLLOVER_ICON_CHANGED_PROPERTY, ROLLOVER_SELECTED_ICON_CHANGED_PROPERTY, SELECTED_ICON_CHANGED_PROPERTY, TEXT_CHANGED_PROPERTY, VERTICAL_ALIGNMENT_CHANGED_PROPERTY, VERTICAL_TEXT_POSITION_CHANGED_PROPERTY`

### Fields inherited from class javax.swing.JComponent

`listenerList, TOOL_TIP_TEXT_KEY, ui, UNDEFINED_CONDITION, WHEN_ANCESTOR_OF_FOCUSED_COMPONENT, WHEN_FOCUSED, WHEN_IN_FOCUSED_WINDOW`

### Fields inherited from class java.awt.Component

`accessibleContext, BOTTOM_ALIGNMENT, CENTER_ALIGNMENT, LEFT_ALIGNMENT, RIGHT_ALIGNMENT, TOP_ALIGNMENT`

### Fields inherited from interface java.awt.image.ImageObserver

`ABORT, ALLBITS, ERROR, FRAMEBITS, HEIGHT, PROPERTIES, SOMEBITS, WIDTH`

### Fields inherited from interface javax.swing.SwingConstants

`BOTTOM, CENTER, EAST, HORIZONTAL, LEADING, LEFT, NEXT, NORTH, NORTH_EAST, NORTH_WEST, PREVIOUS, RIGHT, SOUTH, SOUTH_EAST, SOUTH_WEST, TOP, TRAILING, VERTICAL, WEST`

## Constructor Summary

Constructors
Constructor
Description
`JHSecondaryViewer()`
Create a secondaryviewer.

## Method Summary

Modifier and Type
Method
Description
`void`
`actionPerformed(ActionEvent e)`
Displays the viewer according to the viewerType
`String`
`getContent()`
Returns the content of the secondary viewer
`String`
`getId()`
Returns the ID of the secondary viewer
`String`
`getTextColor()`
Returns the text Color of the activator text
`String`
`getTextFontFamily()`
Returns the text Font family name of the activator text
`String`
`getTextFontSize()`
Returns the text Font family name of the activator text
`String`
`getTextFontStyle()`
Returns the text Font style of the activator text
`String`
`getTextFontWeight()`
Returns the text Font weight of the activator text
`String`
`getViewerActivator()`
Returns the viewer activator
`String`
`getViewerLocation()`
Returns the viewer Location.
`String`
`getViewerName()`
Returns the viewer name
`String`
`getViewerSize()`
Returns the viewer's Size.
`String`
`getViewerStyle()`
Returns the current ViewerStyle
`void`
`setContent(String content)`
Set the content for the secondary viewer
`void`
`setIconByID(String name)`
Sets the icon in the activator by id.
`void`
`setIconByName(String name)`
Sets the icon in the activator by url or id.
`void`
`setId(String id)`
Set the ID for content in the secondary viewer
`void`
`setTextColor(String name)`
Sets the text Color for the activator text.
`void`
`setTextFontFamily(String family)`
Sets the text Font family for the activator text.
`void`
`setTextFontSize(String size)`
Sets the text size for the activator text.
`void`
`setTextFontStyle(String style)`
Sets the text Font Style for the activator text.
`void`
`setTextFontWeight(String weight)`
Sets the text Font Weigth for the activator text.
`void`
`setViewData(View v)`
Sets data optained from the View
`void`
`setViewerActivator(String activator)`
Sets the viewer activator.
`void`
`setViewerLocation(String location)`
Sets the viewer's location to display the content in.
`void`
`setViewerName(String name)`
Sets the viewer name to display the content in.
`void`
`setViewerSize(String size)`
Sets the viewer's size to display the content in.
`void`
`setViewerStyle(String style)`
Sets the viewer style.

### Methods inherited from class javax.swing.JButton

`getAccessibleContext, getUIClassID, isDefaultButton, isDefaultCapable, paramString, removeNotify, setDefaultCapable, updateUI`

### Methods inherited from class javax.swing.AbstractButton

`actionPropertyChanged, addActionListener, addChangeListener, addImpl, addItemListener, checkHorizontalKey, checkVerticalKey, configurePropertiesFromAction, createActionListener, createActionPropertyChangeListener, createChangeListener, createItemListener, doClick, doClick, fireActionPerformed, fireItemStateChanged, fireStateChanged, getAction, getActionCommand, getActionListeners, getChangeListeners, getDisabledIcon, getDisabledSelectedIcon, getDisplayedMnemonicIndex, getHideActionText, getHorizontalAlignment, getHorizontalTextPosition, getIcon, getIconTextGap, getItemListeners, getLabel, getMargin, getMnemonic, getModel, getMultiClickThreshhold, getPressedIcon, getRolloverIcon, getRolloverSelectedIcon, getSelectedIcon, getSelectedObjects, getText, getUI, getVerticalAlignment, getVerticalTextPosition, imageUpdate, init, isBorderPainted, isContentAreaFilled, isFocusPainted, isRolloverEnabled, isSelected, paintBorder, removeActionListener, removeChangeListener, removeItemListener, setAction, setActionCommand, setBorderPainted, setContentAreaFilled, setDisabledIcon, setDisabledSelectedIcon, setDisplayedMnemonicIndex, setEnabled, setFocusPainted, setHideActionText, setHorizontalAlignment, setHorizontalTextPosition, setIcon, setIconTextGap, setLabel, setLayout, setMargin, setMnemonic, setMnemonic, setModel, setMultiClickThreshhold, setPressedIcon, setRolloverEnabled, setRolloverIcon, setRolloverSelectedIcon, setSelected, setSelectedIcon, setText, setUI, setVerticalAlignment, setVerticalTextPosition`

### Methods inherited from class javax.swing.JComponent

`addAncestorListener, addNotify, addVetoableChangeListener, computeVisibleRect, contains, createToolTip, disable, enable, firePropertyChange, firePropertyChange, firePropertyChange, fireVetoableChange, getActionForKeyStroke, getActionMap, getAlignmentX, getAlignmentY, getAncestorListeners, getAutoscrolls, getBaseline, getBaselineResizeBehavior, getBorder, getBounds, getClientProperty, getComponentGraphics, getComponentPopupMenu, getConditionForKeyStroke, getDebugGraphicsOptions, getDefaultLocale, getFontMetrics, getGraphics, getHeight, getInheritsPopupMenu, getInputMap, getInputMap, getInputVerifier, getInsets, getInsets, getListeners, getLocation, getMaximumSize, getMinimumSize, getNextFocusableComponent, getPopupLocation, getPreferredSize, getRegisteredKeyStrokes, getRootPane, getSize, getToolTipLocation, getToolTipText, getToolTipText, getTopLevelAncestor, getTransferHandler, getVerifyInputWhenFocusTarget, getVetoableChangeListeners, getVisibleRect, getWidth, getX, getY, grabFocus, hide, isDoubleBuffered, isLightweightComponent, isManagingFocus, isOpaque, isOptimizedDrawingEnabled, isPaintingForPrint, isPaintingOrigin, isPaintingTile, isRequestFocusEnabled, isValidateRoot, paint, paintChildren, paintComponent, paintImmediately, paintImmediately, print, printAll, printBorder, printChildren, printComponent, processComponentKeyEvent, processKeyBinding, processKeyEvent, processMouseEvent, processMouseMotionEvent, putClientProperty, registerKeyboardAction, registerKeyboardAction, removeAncestorListener, removeVetoableChangeListener, repaint, repaint, requestDefaultFocus, requestFocus, requestFocus, requestFocusInWindow, requestFocusInWindow, resetKeyboardActions, reshape, revalidate, scrollRectToVisible, setActionMap, setAlignmentX, setAlignmentY, setAutoscrolls, setBackground, setBorder, setComponentPopupMenu, setDebugGraphicsOptions, setDefaultLocale, setDoubleBuffered, setFocusTraversalKeys, setFont, setForeground, setInheritsPopupMenu, setInputMap, setInputVerifier, setMaximumSize, setMinimumSize, setNextFocusableComponent, setOpaque, setPreferredSize, setRequestFocusEnabled, setToolTipText, setTransferHandler, setUI, setVerifyInputWhenFocusTarget, setVisible, unregisterKeyboardAction, update`

### Methods inherited from class java.awt.Container

`add, add, add, add, add, addContainerListener, addPropertyChangeListener, addPropertyChangeListener, applyComponentOrientation, areFocusTraversalKeysSet, countComponents, deliverEvent, doLayout, findComponentAt, findComponentAt, getComponent, getComponentAt, getComponentAt, getComponentCount, getComponents, getComponentZOrder, getContainerListeners, getFocusTraversalKeys, getFocusTraversalPolicy, getLayout, getMousePosition, insets, invalidate, isAncestorOf, isFocusCycleRoot, isFocusCycleRoot, isFocusTraversalPolicyProvider, isFocusTraversalPolicySet, layout, list, list, locate, minimumSize, paintComponents, preferredSize, printComponents, processContainerEvent, processEvent, remove, remove, removeAll, removeContainerListener, setComponentZOrder, setFocusCycleRoot, setFocusTraversalPolicy, setFocusTraversalPolicyProvider, transferFocusDownCycle, validate, validateTree`

### Methods inherited from class java.awt.Component

`action, add, addComponentListener, addFocusListener, addHierarchyBoundsListener, addHierarchyListener, addInputMethodListener, addKeyListener, addMouseListener, addMouseMotionListener, addMouseWheelListener, bounds, checkImage, checkImage, coalesceEvents, contains, createImage, createImage, createVolatileImage, createVolatileImage, disableEvents, dispatchEvent, enable, enableEvents, enableInputMethods, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, getBackground, getBounds, getColorModel, getComponentListeners, getComponentOrientation, getCursor, getDropTarget, getFocusCycleRootAncestor, getFocusListeners, getFocusTraversalKeysEnabled, getFont, getForeground, getGraphicsConfiguration, getHierarchyBoundsListeners, getHierarchyListeners, getIgnoreRepaint, getInputContext, getInputMethodListeners, getInputMethodRequests, getKeyListeners, getLocale, getLocation, getLocationOnScreen, getMouseListeners, getMouseMotionListeners, getMousePosition, getMouseWheelListeners, getName, getParent, getPropertyChangeListeners, getPropertyChangeListeners, getSize, getToolkit, getTreeLock, gotFocus, handleEvent, hasFocus, inside, isBackgroundSet, isCursorSet, isDisplayable, isEnabled, isFocusable, isFocusOwner, isFocusTraversable, isFontSet, isForegroundSet, isLightweight, isMaximumSizeSet, isMinimumSizeSet, isPreferredSizeSet, isShowing, isValid, isVisible, keyDown, keyUp, list, list, list, location, lostFocus, mouseDown, mouseDrag, mouseEnter, mouseExit, mouseMove, mouseUp, move, nextFocus, paintAll, postEvent, prepareImage, prepareImage, processComponentEvent, processFocusEvent, processHierarchyBoundsEvent, processHierarchyEvent, processInputMethodEvent, processMouseWheelEvent, remove, removeComponentListener, removeFocusListener, removeHierarchyBoundsListener, removeHierarchyListener, removeInputMethodListener, removeKeyListener, removeMouseListener, removeMouseMotionListener, removeMouseWheelListener, removePropertyChangeListener, removePropertyChangeListener, repaint, repaint, repaint, requestFocus, requestFocus, requestFocusInWindow, resize, resize, setBounds, setBounds, setComponentOrientation, setCursor, setDropTarget, setFocusable, setFocusTraversalKeysEnabled, setIgnoreRepaint, setLocale, setLocation, setLocation, setMixingCutoutShape, setName, setSize, setSize, show, show, size, toString, transferFocus, transferFocusBackward, transferFocusUpCycle`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

## Field Details

### POPUP

public static String POPUP

### SECONDARY_WINDOW

public static String SECONDARY_WINDOW

### LINK_BUTTON

public static String LINK_BUTTON

### LINK_LABEL

public static String LINK_LABEL

## Constructor Details

### JHSecondaryViewer

public JHSecondaryViewer()
Create a secondaryviewer. By default the viewer creates a button with the text of ">"

## Method Details

### setViewData

public void setViewData(View v)
Sets data optained from the View

Specified by:
  `setViewData` in interface `ViewAwareComponent`

### setContent

public void setContent(String content)
Set the content for the secondary viewer

Parameters:
  `content` - a valid URL

### getContent

public String getContent()
Returns the content of the secondary viewer

### setId

public void setId(String id)
Set the ID for content in the secondary viewer

Parameters:
  `content` - a valid URL

### getId

public String getId()
Returns the ID of the secondary viewer

### setViewerName

public void setViewerName(String name)
Sets the viewer name to display the content in. Viewer is only valid for ViewerStyle "SecondaryWindow"

### getViewerName

public String getViewerName()
Returns the viewer name

### setViewerActivator

public void setViewerActivator(String activator)
Sets the viewer activator. Valid activators are

- javax.help.LinkButton
- javax.help.LinkLabel

The new activatory type will be used the next time a view is displayed.

### getViewerActivator

public String getViewerActivator()
Returns the viewer activator

### setViewerStyle

public void setViewerStyle(String style)
Sets the viewer style. There are two valid viewer styles:

- javax.help.SecondaryWindow
- javax.help.Popup

  Viewer style is updated the next time the viewer is made visible

Parameters:
  `style` - a valid ViewerStyle

### getViewerStyle

public String getViewerStyle()
Returns the current ViewerStyle

### setViewerLocation

public void setViewerLocation(String location)
Sets the viewer's location to display the content in. Location is relative to the screen or a modal dialog box The String must be in the form of "x,y". If no viewer location is established the default is 0,0 for secondary windows. Location is ignored for popups.

See Also:
  - `getViewerLocation()`

### getViewerLocation

public String getViewerLocation()
Returns the viewer Location. Location is relative to the screen or a modal dialog box. The form of the location is "x,y". The default location is 0,0.

See Also:
  - `setViewerLocation(java.lang.String)`

### setViewerSize

public void setViewerSize(String size)
Sets the viewer's size to display the content in. The String must be in the form of "width,heigt". If no size is set the default is 200,200.

See Also:
  - `getViewerSize()`

### getViewerSize

public String getViewerSize()
Returns the viewer's Size. The form of the size is "width,height".

See Also:
  - `setViewerSize(java.lang.String)`

### setIconByName

public void setIconByName(String name)
Sets the icon in the activator by url or id. The url is relative to the base address of the document.

See Also:
  - `AbstractButton.getIcon()`

### setIconByID

public void setIconByID(String name)
Sets the icon in the activator by id.

See Also:
  - `AbstractButton.getIcon()`

### setTextFontFamily

public void setTextFontFamily(String family)
Sets the text Font family for the activator text. For JDK 1.1 this must a family name of Dialog, DialogInput, Monospaced, Serif, SansSerif, or Symbol.

### getTextFontFamily

public String getTextFontFamily()
Returns the text Font family name of the activator text

### setTextFontSize

public void setTextFontSize(String size)
Sets the text size for the activator text. The String size is a valid Cascading Style Sheet value for text size. Acceptable values are as follows:

- xx-small
- x-small
- small
- medium
- large
- x-large
- xx-large
- bigger - increase the current base font size by 1
- smaller - decrease the current base font size by 1
- xxpt - set the font size to a specific pt value of "xx"
- +x - increase the current base font size by a value of "x"
- -x - decrease the current base font size by a value of "x"
- x - set the font size to the point size associated with the index "x"

### getTextFontSize

public String getTextFontSize()
Returns the text Font family name of the activator text

### setTextFontWeight

public void setTextFontWeight(String weight)
Sets the text Font Weigth for the activator text. Valid weights are

- plain
- bold

### getTextFontWeight

public String getTextFontWeight()
Returns the text Font weight of the activator text

### setTextFontStyle

public void setTextFontStyle(String style)
Sets the text Font Style for the activator text. Valid font styles are

- plain
- italic

### getTextFontStyle

public String getTextFontStyle()
Returns the text Font style of the activator text

### setTextColor

public void setTextColor(String name)
Sets the text Color for the activator text. The following is a list of supported Color names

- black
- blue
- cyan
- darkGray
- gray
- green
- lightGray
- magenta
- orange
- pink
- red
- white
- yellow

### getTextColor

public String getTextColor()
Returns the text Color of the activator text

### actionPerformed

public void actionPerformed(ActionEvent e)
Displays the viewer according to the viewerType

Specified by:
  `actionPerformed` in interface `ActionListener`